<?php

include_once "init.php";


// ***** Start Output **********************************************************

include_once "header.php";
echo "<h1>Configure</h1>";


// ***** PHP *******************************************************************

if ( count($_POST) &&
    !isset($_POST['Defaults']))
{
  if (preg_match("/(?i:php-development\\.ru)/sDX", $_SERVER['SERVER_NAME']))
  {
    $_POST['__LogFileSize'     ] = min($_POST['__LogFileSize'], $default_LogFileSize);
    $_POST['__MaxActions'      ] = min($_POST['__MaxActions' ], $default_MaxActions );
    $_POST['__MaxClients'      ] = min($_POST['__MaxClients' ], $default_MaxClients );
    $_POST['__MaxRooms'        ] = min($_POST['__MaxRooms'   ], $default_MaxRooms   );
    $_POST['__MaxUsers'        ] = min($_POST['__MaxUsers'   ], $default_MaxUsers   );
    $_POST['__ThreadsMin'      ] = min($_POST['__ThreadsMin' ], $default_ThreadsMin );
    $_POST['__ThreadsMax'      ] = min($_POST['__ThreadsMax' ], $default_ThreadsMax );

    $_POST['__PermAnyRoomAdEdt'] = "0";

    $_POST['__URLRegister'     ] = $default_URLRegister;
    $_POST['__URLLostPass'     ] = $default_URLLostPass;
    $_POST['__URLUpdate'       ] = $default_URLUpdate;
    $_POST['__URLUserInfo'     ] = $default_URLUserInfo;

    $_POST['__URLAdImages'     ] = $default_URLAdImages;
    $_POST['__URLRmImages'     ] = $default_URLRmImages;
    $_POST['__URLInfoGet'      ] = $default_URLInfoGet;
    $_POST['__URLInfoSet'      ] = $default_URLInfoSet;
    $_POST['__URLSendFile'     ] = $default_URLSendFile;
    $_POST['__URLUserAuth'     ] = $default_URLUserAuth;
  }

  if (cfg_set($_POST))
       echo "<div style=\"color: green;\">Done!</div>";
  else echo "<div style=\"color:   red;\">Couldn't write to files!</div>";
}

if (!count($_POST))             $_POST = cfg_get();
if ( isset($_POST['Defaults'])) $_POST =   array();

// ***** inparr ******

function inparr($caption, $name, $default, $init, $done)
{
  ?>
  <tr>
    <td><?=$caption;?></td>
    <td><?php for ($i = $init; $i <= $done; $i++) { ?><input type="text" name="<?=$name;?>[<?=$i;?>]" value="<?=isset($_POST[$name][$i]) ? $_POST[$name][$i] : (!$i ? $default : '');?>" /><?php } ?></td>
  </tr>
  <?php
}

// ***** inptxt ******

function inptxt($caption, $name, $default, $class =  '')
{
  ?>
  <tr>
    <td><?=$caption;?></td>
    <td><input class=<?=$class;?> type="text" name="<?=$name;?>" value="<?=isset($_POST[$name]) ? $_POST[$name] : $default;?>" /></td>
  </tr>
  <?php
}

// ***** select ******

function select($caption, $name, $default)
{
  ?>
  <tr>
    <td><?=$caption;?></td>
    <td>
      <input type="radio" name="<?=$name;?>" value="1"
                 <?=( isset($_POST[$name]) &&  $_POST[$name]) ||
                    (!isset($_POST[$name]) &&   $default) ? "checked=\"checked\"" : "";?> />yes
      <input type="radio" name="<?=$name;?>" value="0"
                 <?=( isset($_POST[$name]) && !$_POST[$name]) ||
                    (!isset($_POST[$name]) && ! $default) ? "checked=\"checked\"" : "";?> />no
    </td>
  </tr>
  <?php
}

// ***** submit ******

function submit()
{
  ?>
  <tr>
    <th>&nbsp;</th>
    <th>
      <input type="submit" value="Submit" />
      <input type="submit" value="Set to Defaults" name="Defaults" onclick="return confirm('Do you really want to reset all settings?');" />
      <input type="submit" value="To the Top of the Page"          onclick="location = '#top'; return false;" />
    </th>
  </tr>
  <?php
}

?>


<?php
// ***** Navigation ************************************************************
?>

<div>
  <a class="header_body" href="#general"     >General</a>
| <a class="header_body" href="#license"     >License</a>
| <a class="header_body" href="#capacity"    >Capacity</a>
| <a class="header_body" href="#defaults"    >Defaults</a>
| <a class="header_body" href="#guests"      >Guests</a>
| <a class="header_body" href="#log"         >Log</a>
| <a class="header_body" href="#mysql"       >MySQL</a>
| <a class="header_body" href="#client"      >Server Load</a>
| <a class="header_body" href="#threads"     >Threads</a>
| <a class="header_body" href="#uploads"     >Uploads</a>
| <a class="header_body" href="#urls_ads"    >Ads URLs</a>
| <a class="header_body" href="#urls_site"   >Site URLs</a>
| <a class="header_body" href="#urls_service">Service URLs</a>
| <a class="header_body" href="#perm"        >User Permissions</a>
</div>


<form method="post" action="config.php">
<table>


<?php
// ***** General ***************************************************************
?>

<tr><td colspan="2"><a class="header_table" name="general">General</a></td></tr>

<?php inparr('Administrative logins'              , '__AdminName'       , $default_AdminName       , 0, 2); ?>
<?php inptxt('Port'                               , '__ListenPort'      , $default_ListenPort      ); ?>
<?php select('External authentication'            , '__ExternAuth'      , $default_ExternAuth      ); ?>
<?php select('MD5-encrypted password'             , '__MD5Crypt'        , $default_MD5Crypt        ); ?>
<?php submit(); ?>


<?php
// ***** License ***************************************************************
?>

<tr><td colspan="2"><a class="header_table" name="license">License</a></td></tr>

<?php inptxt('Code'                               , '__LicenseCode'     , $default_LicenseCode     ); ?>
<?php inptxt('Domain'                             , '__LicenseHost'     , $default_LicenseHost     ); ?>
<?php submit(); ?>


<?php
// ***** Capacity **************************************************************
?>

<tr><td colspan="2"><a class="header_table" name="capacity">Capacity</a></td></tr>

<?php inptxt('Users online'                       , '__MaxClients'      , $default_MaxClients      ); ?>
<?php inptxt('Users'                              , '__MaxUsers'        , $default_MaxUsers        ); ?>
<?php inptxt('Users in audio room'                , '__MaxUsersAudio'   , $default_MaxUsersAudio   ); ?>
<?php inptxt('Users in audio/video room'          , '__MaxUsersAudio'   , $default_MaxUsersVideo   ); ?>
<?php inptxt('Rooms'                              , '__MaxRooms'        , $default_MaxRooms        ); ?>
<?php inptxt('Message queue'                      , '__MaxActions'      , $default_MaxActions      ); ?>
<?php inptxt('Room history size, bytes'           , '__SizeMsgsRoom'    , $default_SizeMsgsRoom    ); ?>
<?php submit(); ?>


<?php
// ***** Defaults **************************************************************
?>

<tr><td colspan="2"><a class="header_table" name="defaults">Defaults</a></td></tr>

<?php inptxt('Group'                              , '__DefaultGrp'      , $default_DefaultGrp      ); ?>
<?php inparr('Rooms'                              , '__Room'            , $default_Room            , 0, 2); ?>
<?php inparr('&nbsp;'                             , '__Room'            , $default_Room            , 3, 5); ?>
<?php inparr('&nbsp;'                             , '__Room'            , $default_Room            , 6, 8); ?>
<?php submit(); ?>


<?php
// ***** Guests ****************************************************************
?>

<tr><td colspan="2"><a class="header_table" name="guests">Guests</a></td></tr>

<?php inptxt('Name prefix'                        , '__GuestPrefix'     , $default_GuestPrefix     ); ?>
<?php select('Guests can enter'                   , '__GuestCanEnter'   , $default_GuestCanEnter   ); ?>
<?php select('Guests can speak'                   , '__GuestCanSpeak'   , $default_GuestCanSpeak   ); ?>
<?php submit(); ?>


<?php
// ***** Log *******************************************************************
?>

<tr><td colspan="2"><a class="header_table" name="log">Log</a></td></tr>

<?php inptxt('Log level'                          , '__LogLevel'        , $default_LogLevel        ); ?>
<?php inptxt('Log file size, mb'                  , '__LogFileSize'     , $default_LogFileSize     ); ?>
<?php select('Log execution time'                 , '__LogProfile'      , $default_LogProfile      ); ?>
<?php select('Log server statistics'              , '__LogServer'       , $default_LogServer       ); ?>
<?php select('Log to screen'                      , '__LogToScrn'       , $default_LogToScrn       ); ?>
<?php select('Log to file'                        , '__LogToFile'       , $default_LogToFile       ); ?>
<?php submit(); ?>


<?php
// ***** MySQL *****************************************************************
?>

<tr><td colspan="2"><a class="header_table" name="mysql">MySQL</a></td></tr>

<?php inptxt('MySQL host'                         , '__MySQLHost'       , $default_MySQLHost       ); ?>
<?php inptxt('MySQL socket (unix)'                , '__MySQLSock'       , $default_MySQLSock       ); ?>
<?php inptxt('MySQL username'                     , '__MySQLUser'       , $default_MySQLUser       ); ?>
<?php inptxt('MySQL password'                     , '__MySQLPass'       , $default_MySQLPass       ); ?>
<?php inptxt('MySQL database'                     , '__MySQLDBase'      , $default_MySQLDBase      ); ?>
<?php inptxt('MySQL table'                        , '__MySQLTable'      , $default_MySQLTable      ); ?>
<?php inptxt('MySQL username column'              , '__MySQLUserCol'    , $default_MySQLUserCol    ); ?>
<?php inptxt('MySQL password column'              , '__MySQLPassCol'    , $default_MySQLPassCol    ); ?>
<?php inptxt('MySQL verified column'              , '__MySQLVeriCol'    , $default_MySQLVeriCol    ); ?>
<?php select('Keep alive MySQL connection'        , '__MySQLKeepAlive'  , $default_MySQLKeepAlive  ); ?>
<?php submit(); ?>


<?php
// ***** Server Load ***********************************************************
?>

<tr><td colspan="2"><a class="header_table" name="client">Server Load</a></td></tr>

<?php inptxt('Ads frequency (main window), sec'   , '__IntervalAdsMain' , $default_IntervalAdsMain ); ?>
<?php inptxt('Ads frequency (rooms, default), sec', '__IntervalAdsRDef' , $default_IntervalAdsRDef ); ?>
<?php inptxt('Ads frequency (rooms, minimum), sec', '__IntervalAdsRMin' , $default_IntervalAdsRMin ); ?>
<?php inptxt('Noop interval, sec'                 , '__IntervalNoop'    , $default_IntervalNoop    ); ?>
<?php inptxt('Send in-room count, sec'            , '__IntervalRCnt'    , $default_IntervalRCnt    ); ?>
<?php inptxt('Typing notification interval, sec'  , '__IntervalType'    , $default_IntervalType    ); ?>
<?php inptxt('Maximum number of search resuls'    , '__MaxUserSrc'      , $default_MaxUserSrc      ); ?>
<?php select('Debug mode'                         , '__Debug'           , $default_Debug           ); ?>
<?php select('Always store user data'             , '__AlwaysStoreUsers', $default_AlwaysStoreUsers); ?>
<?php select('Always store room data'             , '__AlwaysStoreRooms', $default_AlwaysStoreRooms); ?>
<?php submit(); ?>


<?php
// ***** Threads ***************************************************************
?>

<tr><td colspan="2"><a class="header_table" name="threads">Threads</a></td></tr>

<?php inptxt('Service threads min'                , '__ThreadsMin'      , $default_ThreadsMin      ); ?>
<?php inptxt('Service threads max'                , '__ThreadsMax'      , $default_ThreadsMax      ); ?>
<?php inptxt('Sleep if idle, ms'                  , '__ThreadSleep'     , $default_ThreadSleep     ); ?>
<?php submit(); ?>


<?php
// ***** Uploads ***************************************************************
?>

<tr><td colspan="2"><a class="header_table" name="uploads">Uploads</a></td></tr>

<?php inptxt('Maximum file size, kb'              , '__UploadSizeFile'  , $default_UploadSizeFile  ); ?>
<?php inptxt('Keep files on server, min'          , '__UploadKeepTime'  , $default_UploadKeepTime  ); ?>
<?php select('Send files to offline users'        , '__UploadToOffline' , $default_UploadToOffline ); ?>
<?php submit(); ?>


<?php
// ***** Ads URLs **************************************************************
?>

<tr><td colspan="2"><a class="header_table" name="urls_ads">Ads URLs</a></td></tr>

<?php inptxt('Ads (main window)'                  , '__URLAdImages'     , $default_URLAdImages     , 'long'); ?>
<?php inptxt('Ads (rooms)'                        , '__URLRmImages'     , $default_URLRmImages     , 'long'); ?>
<?php select('Allow editing ads in rooms'         , '__PermAnyRoomAdEdt', $default_PermAnyRoomAdEdt); ?>
<?php submit(); ?>


<?php
// ***** Site URLs *************************************************************
?>

<tr><td colspan="2"><a class="header_table" name="urls_site">Site URLs</a></td></tr>

<?php inptxt('Registration'                       , '__URLRegister'     , $default_URLRegister     , 'long'); ?>
<?php inptxt('Password retrieval'                 , '__URLLostPass'     , $default_URLLostPass     , 'long'); ?>
<?php inptxt('Software update'                    , '__URLUpdate'       , $default_URLUpdate       , 'long'); ?>
<?php inptxt('User profile on the web'            , '__URLUserInfo'     , $default_URLUserInfo     , 'long'); ?>
<?php submit(); ?>


<?php
// ***** Service URLs **********************************************************
?>

<tr><td colspan="2"><a class="header_table" name="urls_service">Service URLs</a></td></tr>

<?php inptxt('Send file'                          , '__URLSendFile'     , $default_URLSendFile     , 'long'); ?>
<?php inptxt('User authentication'                , '__URLUserAuth'     , $default_URLUserAuth     , 'long'); ?>
<?php inptxt('Update user info, read'             , '__URLInfoGet'      , $default_URLInfoGet      , 'long'); ?>
<?php inptxt('Update user info, write'            , '__URLInfoSet'      , $default_URLInfoSet      , 'long'); ?>
<?php inptxt('Secret word'                        , '__SecretWord'      , $default_SecretWord      ); ?>
<?php select('Update user info'                   , '__UpdateInfo'      , $default_UpdateInfo      ); ?>

<?php submit(); ?>


<?php
// ***** User Permissions ******************************************************
?>

<tr><td colspan="2"><a class="header_table" name="perm">User permissions</a></td></tr>

<?php select('Create rooms'                       , '__PermUsrRoomGener', $default_PermUsrRoomGener); ?>
<?php select('Create audio rooms'                 , '__PermUsrRoomAudio', $default_PermUsrRoomAudio); ?>
<?php select('Create audio/video rooms'           , '__PermUsrRoomVideo', $default_PermUsrRoomVideo); ?>
<?php select('Create non-expiring rooms'          , '__PermUsrRoomNoExp', $default_PermUsrRoomNoExp); ?>
<?php select('Control room advertising'           , '__PermUsrRoomAdEdt', $default_PermUsrRoomAdEdt); ?>
<?php submit(); ?>


</table>
</form>


<?php include_once "footer.php"; ?>